Create a project

POST /v1/projects

Create a new project and asynchronously setup the tools to manage it. Add a deployable architecture by customizing the configuration. After the changes are validated and approved, deploy the resources that the project configures. For more information, see Creating a project.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to the project creation.

  • project.instance.create

Auditing

Calling this method generates the following auditing event.

  • project.project.create

Request

Request Body

ProjectPrototype

A valid project definition document that adheres to the Project Definition schema.

definition

Required *

ProjectPrototypeDefinition

The definition of the project.

name

Required *

string

The name of the project. It's unique within the account across regions.

description

string

A brief explanation of the project's use in the configuration of a deployable architecture. A project can be created without providing a description.

auto_deploy_mode

object

This is an advanced setting to auto deploy to tell how auto deploy should behave when it is enabled. There are 2 options: > 1. `auto_approval` will automatically approve the configuration after validated without user confirmation. > 2. `manual_approval` will require user confirmation to approve the configuration after validated before deploying the configuration starts.

monitoring_enabled

boolean

A boolean flag to enable automatic drift detection. Use this field to run a daily check to compare the configurations to those deployed resources to detect any difference.

destroy_on_delete

boolean

The policy that indicates whether the resources are undeployed or not when a project is deleted.

owner

string

The owner of the project.

store

object

The details required to custom store project configs.

terraform_engine

object

Experimental schema - this is for prototyping purposes

auto_deploy

boolean

A boolean flag to enable deploying configurations automatically.

configs

ProjectPrototypeConfigs

The project configurations. These configurations are included in the response of creating a project only if a configuration array is specified in the request payload.

environments

ProjectPrototypeEnvironments

The project environment. These environments are included in the response of creating a project only if an environment array is specified in the request payload.

location

Required *

string

The IBM Cloud location where a resource is deployed.

resource_group

Required *

string

The resource group name where the project's data and tools are created.

Response

201 - OK

crn

string

An IBM Cloud resource name that uniquely identifies a resource.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

cumulative_needs_attention_view

CumulativeNeedsAttentionView

The cumulative list of needs attention items for a project. If the view is successfully retrieved, an empty or nonempty array is returned.

cumulative_needs_attention_view_error

boolean

A value of `true` indicates that the fetch of the needs attention items failed. This property only exists if there was an error while retrieving the cumulative needs attention view.

id

object

The unique ID.

location

string

The IBM Cloud location where a resource is deployed.

resource_group_id

string

The resource group ID where the project's data and tools are created.

state

string

The project status value.

href

string

A Url.

resource_group

string

The resource group name where the project's data and tools are created.

event_notifications_crn

string

The CRN of the Event Notifications instance if one is connected to this project.

configs

array

The project configurations. These configurations are only included in the response of creating a project if a configuration array is specified in the request payload.

environments

array

The project environment. These environments are only included in the response if project environments were created on the project.

definition

ProjectDefinition

The definition of the project.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

List projects

GET /v1/projects

List existing projects. Projects are sorted by ID.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to getting projects.

  • project.instance.retrieve-all

Auditing

Calling this method generates the following auditing event.

  • project.project.list

Request

Path Parameters

Query Parameters

token

The server uses this parameter to determine the first entry that is returned on the next page. If this parameter is not specified, the logical first page is returned.

limit

The maximum number of resources to return. The number of resources that are returned is the same, except for the last page.

Response

200 - The request was successful.

limit

integer

A pagination limit.

first

PaginationLink

A pagination link.

next

PaginationLink

A pagination link.

projects

array

An array of projects.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Get a project

GET /v1/projects/{id}

Get information about a project.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to getting a project.

  • project.instance.retrieve

Auditing

Calling this method generates the following auditing event.

  • project.project.read

Request

Response

200 - The request was successful.

crn

string

An IBM Cloud resource name that uniquely identifies a resource.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

cumulative_needs_attention_view

CumulativeNeedsAttentionView

The cumulative list of needs attention items for a project. If the view is successfully retrieved, an empty or nonempty array is returned.

cumulative_needs_attention_view_error

boolean

A value of `true` indicates that the fetch of the needs attention items failed. This property only exists if there was an error while retrieving the cumulative needs attention view.

id

object

The unique ID.

location

string

The IBM Cloud location where a resource is deployed.

resource_group_id

string

The resource group ID where the project's data and tools are created.

state

string

The project status value.

href

string

A Url.

resource_group

string

The resource group name where the project's data and tools are created.

event_notifications_crn

string

The CRN of the Event Notifications instance if one is connected to this project.

configs

array

The project configurations. These configurations are only included in the response of creating a project if a configuration array is specified in the request payload.

environments

array

The project environment. These environments are only included in the response if project environments were created on the project.

definition

ProjectDefinition

The definition of the project.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Update a project

PATCH /v1/projects/{id}

Update a project by specifying its ID.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to updating projects.

  • project.instance.update

Auditing

Calling this method generates the following auditing event.

  • project.project.update

Request

Request Body

ProjectPatch

The request body of the new project definition document.

definition

Required *

ProjectDefinitionPatch

The definition of the project.

name

string

The name of the project. It's unique within the account across regions.

description

string

A brief explanation of the project's use in the configuration of a deployable architecture. A project can be created without providing a description.

auto_deploy_mode

string

This is an advanced setting to auto deploy to tell how auto deploy should behave when it is enabled. There are 2 options: > 1. `auto_approval` will automatically approve the configuration after validated without user confirmation. > 2. `manual_approval` will require user confirmation to approve the configuration after validated before deploying the configuration starts.

monitoring_enabled

boolean

A boolean flag to enable automatic drift detection. Use this field to run a daily check to compare the configurations to the deployed resources to detect any difference.

destroy_on_delete

boolean

The policy that indicates whether the resources are undeployed or not when a project is deleted.

owner

string

The owner of the project.

store

object

The details required to custom store project configs.

terraform_engine

object

Experimental schema - this is for prototyping purposes

auto_deploy

boolean

A boolean flag to enable deploying configurations automatically.

Response

200 - The request was successful.

crn

string

An IBM Cloud resource name that uniquely identifies a resource.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

cumulative_needs_attention_view

CumulativeNeedsAttentionView

The cumulative list of needs attention items for a project. If the view is successfully retrieved, an empty or nonempty array is returned.

cumulative_needs_attention_view_error

boolean

A value of `true` indicates that the fetch of the needs attention items failed. This property only exists if there was an error while retrieving the cumulative needs attention view.

id

object

The unique ID.

location

string

The IBM Cloud location where a resource is deployed.

resource_group_id

string

The resource group ID where the project's data and tools are created.

state

string

The project status value.

href

string

A Url.

resource_group

string

The resource group name where the project's data and tools are created.

event_notifications_crn

string

The CRN of the Event Notifications instance if one is connected to this project.

configs

array

The project configurations. These configurations are only included in the response of creating a project if a configuration array is specified in the request payload.

environments

array

The project environment. These environments are only included in the response if project environments were created on the project.

definition

ProjectDefinition

The definition of the project.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Delete a project

DELETE /v1/projects/{id}

Delete a project document by specifying the ID. A project can be deleted only after deleting all of its resources.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

Delete a project instance by specifying its ID.

  • project.instance.delete

Auditing

Calling this method generates the following auditing event.

  • project.project.delete

Request

Response

202 - The server successfully accepted the request to process the resource.

id

object

The unique ID.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

409 - The project cannot be deleted. At least one of the configurations is in an active pipeline state (validating/deploying/undeploying). Wait for these pipeline actions to end before running the deletion again.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Create an environment

POST /v1/projects/{project_id}/environments

Create an environment to group related configurations together and share values across them for easier deployment. For more information, see Creating an environment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to creating environments.

  • project.environment.create

Auditing

Calling this method generates the following auditing event.

  • project.environment.create

Request

Request Body

EnvironmentPrototype

The request body for a valid environment document.

definition

Required *

EnvironmentDefinitionRequiredProperties

The environment definition.

description

string

The description of the environment.

name

Required *

string

The name of the environment. It's unique within the account across projects and regions.

authorizations

object

The authorization details. It can authorize by using a trusted profile or an API key in Secrets Manager.

inputs

object

The input variables that are used for configuration definition and environment.

compliance_profile

object

The profile that is required for compliance.

Response

201 - The new resource was created.

id

string

The environment ID as a friendly name.

project

ProjectReference

The project that is referenced by this resource.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

target_account

string

The target account ID derived from the authentication block values. The target account exists only if the environment currently has an authorization block.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

href

string

A Url.

definition

EnvironmentDefinitionRequiredPropertiesResponse

The environment definition.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

List environments

GET /v1/projects/{project_id}/environments

List all available environments. For more information, see Creating an environment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to listing environments.

  • project.environment.retrieve-all

Auditing

Calling this method generates the following auditing event.

  • project.environment.list

Request

Path Parameters

Query Parameters

token

The server uses this parameter to determine the first entry that is returned on the next page. If this parameter is not specified, the logical first page is returned.

limit

The maximum number of resources to return. The number of resources that are returned is the same, except for the last page.

Response

200 - The request was successful.

limit

integer

A pagination limit.

first

PaginationLink

A pagination link.

next

PaginationLink

A pagination link.

environments

array

The environment.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Get an environment

GET /v1/projects/{project_id}/environments/{id}

Get an environment. Learn more.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to getting environments.

  • project.environment.retrieve

Auditing

Calling this method generates the following auditing event.

  • project.environment.read

Request

Response

200 - The project environment was successfully retrieved.

id

string

The environment ID as a friendly name.

project

ProjectReference

The project that is referenced by this resource.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

target_account

string

The target account ID derived from the authentication block values. The target account exists only if the environment currently has an authorization block.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

href

string

A Url.

definition

EnvironmentDefinitionRequiredPropertiesResponse

The environment definition.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Update an environment

PATCH /v1/projects/{project_id}/environments/{id}

Update an environment by specifying its ID. Learn more.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to updating an environments.

  • project.environment.update

Auditing

Calling this method generates the following auditing event.

  • project.environment.update

Request

Request Body

EnvironmentPatch

The request body for the updated environment document.

definition

Required *

EnvironmentDefinitionPropertiesPatch

The environment definition that is used for updates.

description

string

The description of the environment.

name

string

The name of the environment. It's unique within the account across projects and regions.

authorizations

object

The authorization details. It can authorize by using a trusted profile or an API key in Secrets Manager.

inputs

object

The input variables that are used for configuration definition and environment.

compliance_profile

object

The profile that is required for compliance.

Response

200 - The project environment was successfully updated.

id

string

The environment ID as a friendly name.

project

ProjectReference

The project that is referenced by this resource.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

target_account

string

The target account ID derived from the authentication block values. The target account exists only if the environment currently has an authorization block.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

href

string

A Url.

definition

EnvironmentDefinitionRequiredPropertiesResponse

The environment definition.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Delete an environment

DELETE /v1/projects/{project_id}/environments/{id}

Delete an environment in a project by specifying its ID.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to the `delete environments` operation.

  • project.environment.delete

Auditing

Calling this method generates the following auditing event.

  • project.environment.delete

Request

Response

200 - The project environment was successfully deleted.

id

string

The environment ID as a friendly name.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Add a new configuration

POST /v1/projects/{project_id}/configs

Add a new configuration to a project.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies to only the `update project` operation.

  • project.config.create

Auditing

Calling this method generates the following auditing event.

  • project.config.create

Request

Request Body

ProjectConfigPrototype

The request body for the new project definition document.

definition

Required *

ProjectConfigDefinitionPrototype

The description of a project configuration.

compliance_profile

object

The profile that is required for compliance.

locator_id

string

A unique concatenation of the catalog ID and the version ID that identify the deployable architecture in the catalog. If importing from an existing Schematics workspace that is not backed by cart, a `locator_id` is required. If using a Schematics workspace that is backed by cart, a `locator_id` is not necessary because the Schematics workspace has one. > There are 3 scenarios: > 1. If only a `locator_id` is specified, a new Schematics workspace is instantiated with that `locator_id`. > 2. If only a schematics `workspace_crn` is specified, a `400` is returned if a `locator_id` is not found in the existing schematics workspace. > 3. If both a Schematics `workspace_crn` and a `locator_id` are specified, a `400` message is returned if the specified `locator_id` does not agree with the `locator_id` in the existing Schematics workspace. > For more information of creating a Schematics workspace, see Creating workspaces and importing the Terraform template.

members

array

The member deployabe architectures that are included in the stack.

uses

array

The depending deployabe architectures that are referenced by this configuration.

description

string

A project configuration description.

name

Required *

string

The configuration name. It's unique within the account across projects and regions.

authorizations

object

The authorization details. It can authorize by using a trusted profile or an API key in Secrets Manager.

inputs

object

The input variables that are used for configuration definition and environment.

settings

object

The Schematics environment variables to use to deploy the configuration. Settings are only available if they are specified when the configuration is initially created.

environment_id

string

The ID of the project environment.

resource_crns

array

The CRNs of the resources that are associated with this configuration.

schematics

SchematicsWorkspace

A Schematics workspace to use for deploying this deployable architecture. > If importing data from an existing Schematics workspace that is not backed by cart, then a `locator_id` must be provided. If using a Schematics workspace that is backed by cart, a `locator_id` is not required because the Schematics workspace has one. > There are 3 scenarios: > 1. If only a `locator_id` is specified, a new Schematics workspace is instantiated with that `locator_id`. > 2. If only a schematics `workspace_crn` is specified, a `400` is returned if a `locator_id` is not found in the existing schematics workspace. > 3. If both a Schematics `workspace_crn` and a `locator_id` are specified, a `400`code is returned if the specified `locator_id` does not agree with the `locator_id` in the existing Schematics workspace. > For more information, see Creating workspaces and importing the Terraform template.

workspace_crn

string

An IBM Cloud resource name that uniquely identifies a resource.

Response

201 - The new resource was created.

id

string

The ID of the configuration. If this parameter is empty, an ID is automatically created for the configuration.

version

integer

The version of the configuration.

needs_attention_state

array

The needs attention state of a configuration.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

outputs

array

The outputs of a Schematics template property.

references

ReferenceValue

The resolved references that are used by the configuration.

state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

config_error

ProjectConfigError

The error from config actions

href

string

A Url.

container_state

string

The aggregate state from all deployabe architectures that are included in this configuration.

container_state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

is_draft

boolean

The flag that indicates whether the version of the configuration is draft, or active.

last_approved

ProjectConfigMetadataLastApproved

The last approved metadata of the configuration.

last_saved_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

last_validated

LastValidatedActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_deployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_undeployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_monitoring

LastMonitoringActionWithSummary

The summary from the last monitoring action job that is performed on the project configuration.

project

ProjectReference

The project that is referenced by this resource.

schematics

SchematicsMetadata

A Schematics workspace that is associated to a project configuration, with scripts.

state

string

The state of the configuration.

update_available

boolean

The flag that indicates whether a configuration update is available.

template_id

object

The unique ID.

member_of

MemberOfDefinition

The stack config parent of which this configuration is a member of.

deployment_model

string

The configuration type.

definition

ProjectConfigDefinitionResponse

The description of a project configuration.

approved_version

ProjectConfigVersionSummary

A summary of a project configuration version.

deployed_version

ProjectConfigVersionSummary

A summary of a project configuration version.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

List all project configurations

GET /v1/projects/{project_id}/configs

Retrieve the collection of configurations.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to the `get project` operation.

  • project.config.retrieve-all

Auditing

Calling this method generates the following auditing event.

  • project.config.list

Request

Path Parameters

Query Parameters

token

The server uses this parameter to determine the first entry that is returned on the next page. If this parameter is not specified, the logical first page is returned.

limit

The maximum number of resources to return. The number of resources that are returned is the same, except for the last page.

Response

200 - The request was successful.

limit

integer

A pagination limit.

first

PaginationLink

A pagination link.

next

PaginationLink

A pagination link.

configs

array

The response schema of the collection list operation that defines the array property with the name `configs`.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Get a project configuration

GET /v1/projects/{project_id}/configs/{id}

Retrieve the specified project configuration in a specific project.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to getting a project configuration.

  • project.config.retrieve

Auditing

Calling this method generates the following auditing event.

  • project.config.read

Request

Response

200 - The request was successful.

id

string

The ID of the configuration. If this parameter is empty, an ID is automatically created for the configuration.

version

integer

The version of the configuration.

needs_attention_state

array

The needs attention state of a configuration.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

outputs

array

The outputs of a Schematics template property.

references

ReferenceValue

The resolved references that are used by the configuration.

state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

config_error

ProjectConfigError

The error from config actions

href

string

A Url.

container_state

string

The aggregate state from all deployabe architectures that are included in this configuration.

container_state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

is_draft

boolean

The flag that indicates whether the version of the configuration is draft, or active.

last_approved

ProjectConfigMetadataLastApproved

The last approved metadata of the configuration.

last_saved_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

last_validated

LastValidatedActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_deployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_undeployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_monitoring

LastMonitoringActionWithSummary

The summary from the last monitoring action job that is performed on the project configuration.

project

ProjectReference

The project that is referenced by this resource.

schematics

SchematicsMetadata

A Schematics workspace that is associated to a project configuration, with scripts.

state

string

The state of the configuration.

update_available

boolean

The flag that indicates whether a configuration update is available.

template_id

object

The unique ID.

member_of

MemberOfDefinition

The stack config parent of which this configuration is a member of.

deployment_model

string

The configuration type.

definition

ProjectConfigDefinitionResponse

The description of a project configuration.

approved_version

ProjectConfigVersionSummary

A summary of a project configuration version.

deployed_version

ProjectConfigVersionSummary

A summary of a project configuration version.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Update a configuration

PATCH /v1/projects/{project_id}/configs/{id}

Update a configuration in a project by specifying the ID. Learn more.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to updating a project configuration.

  • project.config.update

Auditing

Calling this method generates the following auditing event.

  • project.config.update

Request

Request Body

ProjectConfigPatch

The request body for the change delta of the project configuration to update.

definition

Required *

ProjectConfigDefinitionPatch

The name and description of a project configuration.

compliance_profile

object

The profile that is required for compliance.

locator_id

string

A unique concatenation of the catalog ID and the version ID that identify the deployable architecture in the catalog. If importing from an existing Schematics workspace that is not backed by cart, a `locator_id` is required. If using a Schematics workspace that is backed by cart, a `locator_id` is not necessary because the Schematics workspace has one. > There are 3 scenarios: > 1. If only a `locator_id` is specified, a new Schematics workspace is instantiated with that `locator_id`. > 2. If only a schematics `workspace_crn` is specified, a `400` is returned if a `locator_id` is not found in the existing schematics workspace. > 3. If both a Schematics `workspace_crn` and a `locator_id` are specified, a `400` message is returned if the specified `locator_id` does not agree with the `locator_id` in the existing Schematics workspace. > For more information of creating a Schematics workspace, see Creating workspaces and importing the Terraform template.

members

array

The member deployabe architectures that are included in the stack.

uses

array

The depending deployabe architectures that are referenced by this configuration.

description

string

A project configuration description.

name

string

The configuration name. It's unique within the account across projects and regions.

authorizations

object

The authorization details. It can authorize by using a trusted profile or an API key in Secrets Manager.

inputs

object

The input variables that are used for configuration definition and environment.

settings

object

The Schematics environment variables to use to deploy the configuration. Settings are only available if they are specified when the configuration is initially created.

environment_id

string

The ID of the project environment.

resource_crns

array

The CRNs of the resources that are associated with this configuration.

Response

200 - The request was successful.

id

string

The ID of the configuration. If this parameter is empty, an ID is automatically created for the configuration.

version

integer

The version of the configuration.

needs_attention_state

array

The needs attention state of a configuration.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

outputs

array

The outputs of a Schematics template property.

references

ReferenceValue

The resolved references that are used by the configuration.

state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

config_error

ProjectConfigError

The error from config actions

href

string

A Url.

container_state

string

The aggregate state from all deployabe architectures that are included in this configuration.

container_state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

is_draft

boolean

The flag that indicates whether the version of the configuration is draft, or active.

last_approved

ProjectConfigMetadataLastApproved

The last approved metadata of the configuration.

last_saved_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

last_validated

LastValidatedActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_deployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_undeployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_monitoring

LastMonitoringActionWithSummary

The summary from the last monitoring action job that is performed on the project configuration.

project

ProjectReference

The project that is referenced by this resource.

schematics

SchematicsMetadata

A Schematics workspace that is associated to a project configuration, with scripts.

state

string

The state of the configuration.

update_available

boolean

The flag that indicates whether a configuration update is available.

template_id

object

The unique ID.

member_of

MemberOfDefinition

The stack config parent of which this configuration is a member of.

deployment_model

string

The configuration type.

definition

ProjectConfigDefinitionResponse

The description of a project configuration.

approved_version

ProjectConfigVersionSummary

A summary of a project configuration version.

deployed_version

ProjectConfigVersionSummary

A summary of a project configuration version.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Delete a configuration

DELETE /v1/projects/{project_id}/configs/{id}

Delete a configuration in a project by specifying its ID.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to deleting a configuration.

  • project.config.delete

Auditing

Calling this method generates the following auditing event.

  • project.config.delete

Request

Response

200 - The request was successful.

id

object

The unique ID.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Force approve a project configuration

POST /v1/projects/{project_id}/configs/{id}/force_approve

Force approve configuration edits to the main configuration with an approving comment.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to the project configuration force approve action.

  • project.config.force-approve

Auditing

Calling this method generates the following auditing event.

  • project.config.force-approve

Request

Request Body

ProjectConfigForceApproveCommentPrototype

The comment to support the force approve action.

comment

Required *

string

Notes on the project draft action. If this action is a force approve on the draft configuration, it must include a nonempty comment.

Response

200 - The project configuration was successfully force approved.

id

string

The ID of the configuration. If this parameter is empty, an ID is automatically created for the configuration.

version

integer

The version of the configuration.

needs_attention_state

array

The needs attention state of a configuration.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

outputs

array

The outputs of a Schematics template property.

references

ReferenceValue

The resolved references that are used by the configuration.

state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

config_error

ProjectConfigError

The error from config actions

href

string

A Url.

container_state

string

The aggregate state from all deployabe architectures that are included in this configuration.

container_state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

is_draft

boolean

The flag that indicates whether the version of the configuration is draft, or active.

last_approved

ProjectConfigMetadataLastApproved

The last approved metadata of the configuration.

last_saved_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

last_validated

LastValidatedActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_deployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_undeployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_monitoring

LastMonitoringActionWithSummary

The summary from the last monitoring action job that is performed on the project configuration.

project

ProjectReference

The project that is referenced by this resource.

schematics

SchematicsMetadata

A Schematics workspace that is associated to a project configuration, with scripts.

state

string

The state of the configuration.

update_available

boolean

The flag that indicates whether a configuration update is available.

template_id

object

The unique ID.

member_of

MemberOfDefinition

The stack config parent of which this configuration is a member of.

deployment_model

string

The configuration type.

definition

ProjectConfigDefinitionResponse

The description of a project configuration.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters that are in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Approve and merge a configuration draft

POST /v1/projects/{project_id}/configs/{id}/approve

Approve and merge configuration edits to the main configuration.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies to only the approve project configuration action.

  • project.config.approve

Auditing

Calling this method generates the following auditing event.

  • project.config.approve

Request

Request Body

ProjectConfigApproveCommentPrototype

The comment to support the approve action.

comment

string

Notes on the project draft action. If this action is a force approve on the draft configuration, it must include a nonempty comment.

Response

200 - The configuration draft was successfully approved and merged.

id

string

The ID of the configuration. If this parameter is empty, an ID is automatically created for the configuration.

version

integer

The version of the configuration.

needs_attention_state

array

The needs attention state of a configuration.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

outputs

array

The outputs of a Schematics template property.

references

ReferenceValue

The resolved references that are used by the configuration.

state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

config_error

ProjectConfigError

The error from config actions

href

string

A Url.

container_state

string

The aggregate state from all deployabe architectures that are included in this configuration.

container_state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

is_draft

boolean

The flag that indicates whether the version of the configuration is draft, or active.

last_approved

ProjectConfigMetadataLastApproved

The last approved metadata of the configuration.

last_saved_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

last_validated

LastValidatedActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_deployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_undeployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_monitoring

LastMonitoringActionWithSummary

The summary from the last monitoring action job that is performed on the project configuration.

project

ProjectReference

The project that is referenced by this resource.

schematics

SchematicsMetadata

A Schematics workspace that is associated to a project configuration, with scripts.

state

string

The state of the configuration.

update_available

boolean

The flag that indicates whether a configuration update is available.

template_id

object

The unique ID.

member_of

MemberOfDefinition

The stack config parent of which this configuration is a member of.

deployment_model

string

The configuration type.

definition

ProjectConfigDefinitionResponse

The description of a project configuration.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Run a validation check

POST /v1/projects/{project_id}/configs/{id}/validate

Run a validation check on a specific configuration in the project. The check includes creating or updating the associated Schematics workspace with a plan job, running the CRA scans, and cost estimation.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to the project configuration validation check.

  • project.config.validate

Auditing

Calling this method generates the following auditing event.

  • project.config.validate

Request

Response

202 - The server successfully accepted the request to process the resource.

id

string

The ID of the configuration. If this parameter is empty, an ID is automatically created for the configuration.

version

integer

The version of the configuration.

needs_attention_state

array

The needs attention state of a configuration.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

outputs

array

The outputs of a Schematics template property.

references

ReferenceValue

The resolved references that are used by the configuration.

state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

config_error

ProjectConfigError

The error from config actions

href

string

A Url.

container_state

string

The aggregate state from all deployabe architectures that are included in this configuration.

container_state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

is_draft

boolean

The flag that indicates whether the version of the configuration is draft, or active.

last_approved

ProjectConfigMetadataLastApproved

The last approved metadata of the configuration.

last_saved_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

last_validated

LastValidatedActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_deployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_undeployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_monitoring

LastMonitoringActionWithSummary

The summary from the last monitoring action job that is performed on the project configuration.

project

ProjectReference

The project that is referenced by this resource.

schematics

SchematicsMetadata

A Schematics workspace that is associated to a project configuration, with scripts.

state

string

The state of the configuration.

update_available

boolean

The flag that indicates whether a configuration update is available.

template_id

object

The unique ID.

member_of

MemberOfDefinition

The stack config parent of which this configuration is a member of.

deployment_model

string

The configuration type.

definition

ProjectConfigDefinitionResponse

The description of a project configuration.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

409 - The request cannot be processed because of a conflict between the request and the current client-controlled state in the system.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Run a prevalidation check

POST /v1/projects/{project_id}/configs/{id}/prevalidate

Run a validation check a configuration passed via the API. The check includes creating a Schematics workspace with a plan job, running the CRA scans, and cost estimation.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to the project configuration validation check.

  • project.config.validate

Auditing

Calling this method generates the following auditing event.

  • project.config.validate

Request

Request Body

ProjectConfigPrototype

definition

Required *

ProjectConfigDefinitionPrototype

The description of a project configuration.

compliance_profile

object

The profile that is required for compliance.

locator_id

string

A unique concatenation of the catalog ID and the version ID that identify the deployable architecture in the catalog. If importing from an existing Schematics workspace that is not backed by cart, a `locator_id` is required. If using a Schematics workspace that is backed by cart, a `locator_id` is not necessary because the Schematics workspace has one. > There are 3 scenarios: > 1. If only a `locator_id` is specified, a new Schematics workspace is instantiated with that `locator_id`. > 2. If only a schematics `workspace_crn` is specified, a `400` is returned if a `locator_id` is not found in the existing schematics workspace. > 3. If both a Schematics `workspace_crn` and a `locator_id` are specified, a `400` message is returned if the specified `locator_id` does not agree with the `locator_id` in the existing Schematics workspace. > For more information of creating a Schematics workspace, see Creating workspaces and importing the Terraform template.

members

array

The member deployabe architectures that are included in the stack.

uses

array

The depending deployabe architectures that are referenced by this configuration.

description

string

A project configuration description.

name

Required *

string

The configuration name. It's unique within the account across projects and regions.

authorizations

object

The authorization details. It can authorize by using a trusted profile or an API key in Secrets Manager.

inputs

object

The input variables that are used for configuration definition and environment.

settings

object

The Schematics environment variables to use to deploy the configuration. Settings are only available if they are specified when the configuration is initially created.

environment_id

string

The ID of the project environment.

resource_crns

array

The CRNs of the resources that are associated with this configuration.

schematics

SchematicsWorkspace

A Schematics workspace to use for deploying this deployable architecture. > If importing data from an existing Schematics workspace that is not backed by cart, then a `locator_id` must be provided. If using a Schematics workspace that is backed by cart, a `locator_id` is not required because the Schematics workspace has one. > There are 3 scenarios: > 1. If only a `locator_id` is specified, a new Schematics workspace is instantiated with that `locator_id`. > 2. If only a schematics `workspace_crn` is specified, a `400` is returned if a `locator_id` is not found in the existing schematics workspace. > 3. If both a Schematics `workspace_crn` and a `locator_id` are specified, a `400`code is returned if the specified `locator_id` does not agree with the `locator_id` in the existing Schematics workspace. > For more information, see Creating workspaces and importing the Terraform template.

workspace_crn

string

An IBM Cloud resource name that uniquely identifies a resource.

Response

202 - The prevalidated request was accepted.

result_id

string

The result id to use to get prevalidation results.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in your request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

409 - The request cannot be processed because of a conflict between the request and the current client-controlled state in the system.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Get prevalidate results

GET /v1/projects/{project_id}/configs/{id}/prevalidate/{result_id}

Retrieve the prevalidate results using a key.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies to the project configuration validation check.

  • project.config.validate

Auditing

Calling this method generates the following auditing event.

  • project.config.validate

Request

Response

200 - The prevalidate results were successfully retrieved.

cost_estimate

ProjectConfigMetadataCostEstimate

The cost estimate of the configuration. This property exists only after the first configuration validation.

cra_logs

ProjectConfigMetadataCodeRiskAnalyzerLogs

The Code Risk Analyzer logs of the configuration. This property is populated only after the validation step when the Code Risk Analyzer is run. Note: `cra` is the abbreviated form of Code Risk Analyzer.

job

ActionJobWithIdAndSummary

A brief summary of an action.

pre_job

PrePostActionJobWithIdAndSummary

A brief summary of a pre- and post-action.

post_job

PrePostActionJobWithIdAndSummary

A brief summary of a pre- and post-action.

result

string

The result of the last action.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

500 - The request could not be completed by the server. It could be due to an internal error or in some cases invalid data in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

default - The request encountered a system problem or unexpected error.

Deploy a configuration

POST /v1/projects/{project_id}/configs/{id}/deploy

Deploy a project's configuration. This operation is asynchronous and can be tracked by using the get project configuration API with full metadata.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to deploying a project configuration.

  • project.config.deploy

Auditing

Calling this method generates the following auditing event.

  • project.config.deploy

Request

Response

202 - The server successfully accepted the request to process the resource.

id

string

The ID of the configuration. If this parameter is empty, an ID is automatically created for the configuration.

version

integer

The version of the configuration.

needs_attention_state

array

The needs attention state of a configuration.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

outputs

array

The outputs of a Schematics template property.

references

ReferenceValue

The resolved references that are used by the configuration.

state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

config_error

ProjectConfigError

The error from config actions

href

string

A Url.

container_state

string

The aggregate state from all deployabe architectures that are included in this configuration.

container_state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

is_draft

boolean

The flag that indicates whether the version of the configuration is draft, or active.

last_approved

ProjectConfigMetadataLastApproved

The last approved metadata of the configuration.

last_saved_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

last_validated

LastValidatedActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_deployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_undeployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_monitoring

LastMonitoringActionWithSummary

The summary from the last monitoring action job that is performed on the project configuration.

project

ProjectReference

The project that is referenced by this resource.

schematics

SchematicsMetadata

A Schematics workspace that is associated to a project configuration, with scripts.

state

string

The state of the configuration.

update_available

boolean

The flag that indicates whether a configuration update is available.

template_id

object

The unique ID.

member_of

MemberOfDefinition

The stack config parent of which this configuration is a member of.

deployment_model

string

The configuration type.

definition

ProjectConfigDefinitionResponse

The description of a project configuration.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

409 - The request cannot be processed because of a conflict between the request and the current client-controlled state in the system.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Undeploy configuration resources

POST /v1/projects/{project_id}/configs/{id}/undeploy

Undeploy a project's configuration resources. The operation undeploys all the resources that are deployed with the specific configuration. The configuration resources can be tracked by using the get project configuration API with full metadata.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to undeploying project configuration resources.

  • project.config.undeploy

Auditing

Calling this method generates the following auditing event.

  • project.config.undeploy

Request

Response

202 - The server successfully accepted the request to process the resource.

id

string

The ID of the configuration. If this parameter is empty, an ID is automatically created for the configuration.

version

integer

The version of the configuration.

needs_attention_state

array

The needs attention state of a configuration.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

outputs

array

The outputs of a Schematics template property.

references

ReferenceValue

The resolved references that are used by the configuration.

state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

config_error

ProjectConfigError

The error from config actions

href

string

A Url.

container_state

string

The aggregate state from all deployabe architectures that are included in this configuration.

container_state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

is_draft

boolean

The flag that indicates whether the version of the configuration is draft, or active.

last_approved

ProjectConfigMetadataLastApproved

The last approved metadata of the configuration.

last_saved_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

last_validated

LastValidatedActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_deployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_undeployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_monitoring

LastMonitoringActionWithSummary

The summary from the last monitoring action job that is performed on the project configuration.

project

ProjectReference

The project that is referenced by this resource.

schematics

SchematicsMetadata

A Schematics workspace that is associated to a project configuration, with scripts.

state

string

The state of the configuration.

update_available

boolean

The flag that indicates whether a configuration update is available.

template_id

object

The unique ID.

member_of

MemberOfDefinition

The stack config parent of which this configuration is a member of.

deployment_model

string

The configuration type.

definition

ProjectConfigDefinitionResponse

The description of a project configuration.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

409 - The request cannot be processed because of a conflict between the request and the current client-controlled state in the system.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Sync a project configuration

POST /v1/projects/{project_id}/configs/{id}/sync

Sync a project configuration by analyzing the associated pipeline runs and Schematics workspace logs to get the configuration back to a working state.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to sync'ing project configuration.

  • project.config.sync

Auditing

Calling this method generates the following auditing event.

  • project.config.update

Request

Request Body

SchematicsWorkspaceIdentity

An optional Schematics workspace to be used by this configuration.

schematics

SchematicsWorkspace

A Schematics workspace to use for deploying this deployable architecture. > If importing data from an existing Schematics workspace that is not backed by cart, then a `locator_id` must be provided. If using a Schematics workspace that is backed by cart, a `locator_id` is not required because the Schematics workspace has one. > There are 3 scenarios: > 1. If only a `locator_id` is specified, a new Schematics workspace is instantiated with that `locator_id`. > 2. If only a schematics `workspace_crn` is specified, a `400` is returned if a `locator_id` is not found in the existing schematics workspace. > 3. If both a Schematics `workspace_crn` and a `locator_id` are specified, a `400`code is returned if the specified `locator_id` does not agree with the `locator_id` in the existing Schematics workspace. > For more information, see Creating workspaces and importing the Terraform template.

workspace_crn

string

An IBM Cloud resource name that uniquely identifies a resource.

Response

204 - The request was successful but the response is empty.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

409 - The request cannot be processed because of a conflict between the request and the current client-controlled state in the system.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

List all deployed resources

GET /v1/projects/{project_id}/configs/{id}/resources

List resources that are deployed by a configuration.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to the project get configuration resources.

  • project.config.retrieve-resources

Auditing

Calling this method generates the following auditing event.

  • project.config.read

Request

Response

200 - The deployed resources were successfully updated.

resources

array

The collection list operation response schema that defines the array property with the name `resources`.

resources_count

integer

The total number of resources that are deployed by the configuration.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Create a stack definition

POST /v1/projects/{project_id}/configs/{id}/stack_definition

Defines inputs at the stack level that users need to configure along with input values at the member level. These values are included in the catalog entry when the deployable architecture stack is exported to a private catalog and are required for the deployable architecture stack to deploy. A reference can be added to a value, or add the value explicitly at the member level.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to creating a stack definition.

  • project.config.create-stack-definition

Auditing

Calling this method generates the following auditing event.

  • project.config.create

Request

Request Body

StackDefinitionPrototype

The new stack definition document.

stack_definition

Required *

StackDefinitionBlockPrototype

The definition block for a stack definition.

inputs

array

Defines the inputs that users need to configure at the stack level. These inputs are included in the catalog entry when the deployable architecture stack is exported to a private catalog.

outputs

array

The outputs associated with this stack definition

Response

201 - The new resource was created.

id

string

The ID of the stack definition.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

configuration

object

The stack parent configiguration to which the stack definition belongs.

href

object

A Url.

stack_definition

StackDefinitionBlock

The definition block for a stack definition.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Get a stack definition

GET /v1/projects/{project_id}/configs/{id}/stack_definition

Retrieve the stack definition that is associated to the configuration.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to retrieving a stack definition.

  • project.config.retrieve-stack-definition

Auditing

Calling this method generates the following auditing event.

  • project.config.read

Request

Response

200 - The new resource was created.

id

string

The ID of the stack definition.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

configuration

object

The stack parent configiguration to which the stack definition belongs.

href

object

A Url.

stack_definition

StackDefinitionBlock

The definition block for a stack definition.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Update a stack definition

PATCH /v1/projects/{project_id}/configs/{id}/stack_definition

Update the stack definition that is associated with the configuration.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to updating a stack definition.

  • project.config.update-stack-definition

Auditing

Calling this method generates the following auditing event.

  • project.config.update

Request

Request Body

StackDefinitionPrototype

The change delta of the stack definition to update.

stack_definition

Required *

StackDefinitionBlockPrototype

The definition block for a stack definition.

inputs

array

Defines the inputs that users need to configure at the stack level. These inputs are included in the catalog entry when the deployable architecture stack is exported to a private catalog.

outputs

array

The outputs associated with this stack definition

Response

200 - The request was successful.

id

string

The ID of the stack definition.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

configuration

object

The stack parent configiguration to which the stack definition belongs.

href

object

A Url.

stack_definition

StackDefinitionBlock

The definition block for a stack definition.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Export a deployable architecture stack to the private catalog

POST /v1/projects/{project_id}/configs/{id}/stack_definition/export

Exports the deployable architecture stack to a private catalog. All member deployable architectures within the stack must be validated and deployed before the stack is exported. The stack definition must also exist before the stack is exported. The stack can be exported as a new product, or as a new version of an existing product.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies to exporting a configuration stack definition to the private catalog.

  • project.config.export-stack-definition

Auditing

Calling this method generates the following auditing event.

  • project.config.export-stack-definition

Request

Request Body

StackDefinitionExportRequest

The payload for the private catalog export request.

Response

200 - The request was successful.

catalog_id

string

The catalog ID to publish.

target_version

string

The semver value of this new version of the product

variation

string

The variation of the current software being onboarded. Only valid if the Product kind is module or solution. See `flavor` in Catalog's import offering.

product_id

string

The product ID to publish.

version_locator

object

A unique concatenation of the catalog ID and the version ID that identify the deployable architecture in the catalog. If importing from an existing Schematics workspace that is not backed by cart, a `locator_id` is required. If using a Schematics workspace that is backed by cart, a `locator_id` is not necessary because the Schematics workspace has one. > There are 3 scenarios: > 1. If only a `locator_id` is specified, a new Schematics workspace is instantiated with that `locator_id`. > 2. If only a schematics `workspace_crn` is specified, a `400` is returned if a `locator_id` is not found in the existing schematics workspace. > 3. If both a Schematics `workspace_crn` and a `locator_id` are specified, a `400` message is returned if the specified `locator_id` does not agree with the `locator_id` in the existing Schematics workspace. > For more information of creating a Schematics workspace, see Creating workspaces and importing the Terraform template.

kind

string

The type of catalog entry, typically terraform.

format

string

Content kind, e.g., stack, helm, vm image

label

string

The product label

tags

array

Tags associated with the catalog product

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Get a list of project configuration versions

GET /v1/projects/{project_id}/configs/{id}/versions

Retrieve a list of previous and current versions of a project configuration in a specific project.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to the get project configuration drafts action.

  • project.config.retrieve-all-version

Auditing

Calling this method generates the following auditing event.

  • project.config.list

Request

Response

200 - The configuration versions were successfully retrieved.

versions

array

The collection list operation response schema that defines the array property with the name `versions`.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Get a specific project configuration version

GET /v1/projects/{project_id}/configs/{id}/versions/{version}

Retrieve a specific version of a configuration in a project.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to getting a project configuration version.

  • project.config.retrieve-version

Auditing

Calling this method generates the following auditing event.

  • project.config.read

Request

Response

200 - The version was successfully retrieved.

id

string

The ID of the configuration. If this parameter is empty, an ID is automatically created for the configuration.

version

integer

The version of the configuration.

needs_attention_state

array

The needs attention state of a configuration.

created_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

modified_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

outputs

array

The outputs of a Schematics template property.

references

ReferenceValue

The resolved references that are used by the configuration.

state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

config_error

ProjectConfigError

The error from config actions

href

string

A Url.

container_state

string

The aggregate state from all deployabe architectures that are included in this configuration.

container_state_code

string

Computed state code clarifying the prerequisites for validation for the configuration.

is_draft

boolean

The flag that indicates whether the version of the configuration is draft, or active.

last_approved

ProjectConfigMetadataLastApproved

The last approved metadata of the configuration.

last_saved_at

string

A date and time value in the format YYYY-MM-DDTHH:mm:ssZ or YYYY-MM-DDTHH:mm:ss.sssZ to match the date and time format as specified by RFC 3339.

last_validated

LastValidatedActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_deployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_undeployed

LastActionWithSummary

The href and results from the last action job that is performed on the project configuration.

last_monitoring

LastMonitoringActionWithSummary

The summary from the last monitoring action job that is performed on the project configuration.

project

ProjectReference

The project that is referenced by this resource.

schematics

SchematicsMetadata

A Schematics workspace that is associated to a project configuration, with scripts.

state

string

The state of the configuration.

update_available

boolean

The flag that indicates whether a configuration update is available.

template_id

object

The unique ID.

member_of

MemberOfDefinition

The stack config parent of which this configuration is a member of.

deployment_model

string

The configuration type.

definition

ProjectConfigDefinitionResponse

The description of a project configuration.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

Delete a project configuration version

DELETE /v1/projects/{project_id}/configs/{id}/versions/{version}

Delete a configuration version by specifying the project ID.

Authorization

To call this method, you must be assigned one or more IAM access roles that include the following action.

This action applies only to the configuration delete.

  • project.config.delete-version

Auditing

Calling this method generates the following auditing event.

  • project.config.delete

Request

Response

200 - The configuration version was successfully deleted.

id

object

The unique ID.

400 - The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all the required parameters in the request.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

401 - The credentials are invalid or authentication is required to succeed.

errors

array

Detailed errors list

trace

string

A lowercase UUID that uniquely identifies the request.

status_code

integer

The status code that is used for the response.

403 - The supplied authentication is not authorized to view this resource.

[...]
